#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <queue>
#include <deque>
#include <complex>
#include <tuple>

using namespace std;

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define fs first
#define sc second
#define pbk pop_back
#define sz(s) ((int) (s).size())
#define all(x) (x).begin(), (x).end()
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#if _WIN32 || __WIN32__ || _WIN64 || __WIN64__
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#define next _next
#define prev _prev
#define link _link
#define rank _rank
#define hash _hash
#define y1 yy1

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long double ld;

const int inf = 1e9;
const double eps = 1e-9;
const double pi = 4 * atan(1.0);
const int N = 5010;

inline double sqr(double x) {
    return x * x;
}

struct point {
    
    double x, y;
    
    point() {}
    
    point(double x, double y) : x(x), y(y) {}
    
    point to_len(double len) {
        double d = sqrt(sqr(x) + sqr(y));
        return point(x / d * len, y / d * len);
    }
    
    point rot90() {
        return point(-y, x);
    }
    
};

point operator + (const point& a, const point& b) {
    return point(a.x + b.x, a.y + b.y);
}

point operator - (const point& a, const point& b) {
    return point(a.x - b.x, a.y - b.y);
}

point operator / (const point& a, double b) {
    return point(a.x / b, a.y / b);
}

struct circle {
    
    point p;
    double r;
    
    inline void read() {
        scanf("%lf %lf %lf", &p.x, &p.y, &r);
    }
    
};

struct line {
    
    double a, b, c, ang;
    int num;
    
    line() {}
    
    line(const point& A, const point& B) {
        a = A.y - B.y;
        b = B.x - A.x;
        c = -a * A.x - b * A.y;
    }
    
    inline void norm() {
        double d = sqrt(sqr(a) + sqr(b));
        a /= d;
        b /= d;
        c /= d;
    }
    
};

bool operator < (const line& a, const line& b) {
    if (fabs(a.ang - b.ang) < eps) {
        return a.c < b.c;
    }
    return a.ang < b.ang;
}

bool operator == (const line& a, const line& b) {
    return fabs(a.ang - b.ang) < eps;
}

circle c[N];
line l[N], st[N];
point p[N];
int last[N];

inline double dist(const point& a, const point& b) {
    return sqr(a.x - b.x) + sqr(a.y - b.y);
}

inline double dist(const line& l, const point& p) {
    return sqr(l.a * p.x + l.b * p.y + l.c);
}

inline point intersect(line l1, line l2) {
    double d = l1.a * l2.b - l2.a * l1.b;
    point res((l1.b * l2.c - l2.b * l1.c) / d, (l2.a * l1.c - l1.a * l2.c) / d);
    return res;
}

inline point intersect(circle c, line l) {
    l.norm();
    double d = sqrt(max(sqr(c.r) - dist(l, c.p), 0.0));
    line l2 = l;
    swap(l2.a, l2.b);
    l2.a *= -1;
    l2.c = -l2.a * c.p.x - l2.b * c.p.y;
    l2.c -= d;
    point res = intersect(l, l2);
    return res;
}

inline point intersect(circle a, circle b) {
    line l;
    l.a = 2 * (b.p.x - a.p.x);
    l.b = 2 * (b.p.y - a.p.y);
    l.c = sqr(a.p.x) + sqr(a.p.y) - sqr(a.r) - sqr(b.p.x) - sqr(b.p.y) + sqr(b.r);
    point res = intersect(a, l);
    return res;
}

inline double scal(point a, point b) {
    return a.x * b.x + a.y * b.y;
}

inline line build_radical(circle a, circle b) {
    if (fabs(a.r - b.r) < eps) {
        return line((a.p + b.p) / 2, (a.p + b.p) / 2 + (b.p - a.p).rot90().to_len(a.r));
    }
    if (a.r > b.r) {
        swap(a, b);
    }
    b.r -= a.r;
    circle na;
    na.p = a.p;
    na.r = sqrt(max(dist(a.p, b.p) - sqr(b.r), 0.0));
    point pb = intersect(na, b);
    point v = (pb - b.p).to_len(a.r);
    point pa = a.p + v;
    pb = pb + v;
    b.r += a.r;
    point c = (pa + pb) / 2;
    line res(a.p, b.p);
    swap(res.a, res.b);
    res.a *= -1;
    res.c = -res.a * c.x - res.b * c.y;
    return res;
}

inline double dist2(const line& l, const point& p) {
    return l.a * p.x + l.b * p.y + l.c;
}

line l2[N];

inline int build_inter(int n) {
    int old_n = n;
    for (int i = 0; i < n; ++i) {
        l[i].norm();
        l2[i] = l[i];
        l[i].ang = atan2(l[i].b, l[i].a);
    }
    sort(l, l + n);
    n = unique(l, l + n) - l;
    for (int i = 0; i < n; ++i) {
        l[i].num = i;
    }
    for (int i = n; i < 2 * n; ++i) {
        l[i] = l[i - n];
        l[i].ang += 2 * pi;
    }
    int sz = 0;
    for (int i = 0; i < 2 * n; ++i) {
        while (sz >= 2) {
            if (l[i].ang - st[sz - 2].ang > pi - eps) {
                break;
            }
            point cp = intersect(l[i], st[sz - 2]);
            if (dist2(st[sz - 1], cp) > -eps) {
                --sz;
            } else {
                break;
            }
        }
        st[sz++] = l[i];
    }
    for (int i = 0; i < n; ++i) {
        last[i] = -1;
    }
    for (int i = 0; i < sz; ++i) {
        if (last[st[i].num] != -1) {
            int ptr = 0;
            for (int j = last[st[i].num]; j < i; ++j) {
                l[ptr++] = st[j];
            }
            return ptr;
        }
        last[st[i].num] = i;
    }
    assert(false);
}

int main() {
#ifdef LOCAL42
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    double w, h;
    int n;
    cin >> w >> h >> n;
    for (int i = 0; i < n; ++i) {
        c[i].read();
    }
    for (int i = 0; i < n; ++i) {
        int sz = 0;
        l[sz++] = line(point(0, 0), point(w, 0));
        l[sz++] = line(point(w, 0), point(w, h));
        l[sz++] = line(point(w, h), point(0, h));
        l[sz++] = line(point(0, h), point(0, 0));
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                line cur = build_radical(c[i], c[j]);
                if (dist2(cur, c[i].p) < 0) {
                    cur.a *= -1;
                    cur.b *= -1;
                    cur.c *= -1;
                }
                l[sz++] = cur;
            }
        }
        sz = build_inter(sz);
        printf("%d\n", sz);
        for (int j = 0; j < sz; ++j) {
            point cp = intersect(l[j], l[(j + 1) % sz]);
            printf("%.18lf %.18lf\n", cp.x, cp.y);
        }
    }
    return 0;
}